/****************************************************************************

	File    : Sample\Sample\OSample.cpp  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Sample/Sample/OSample.h"
#include "Server/tools/tools.h"
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


// ==============================================================> usage <===
/*
#ifdef __USAGE
%C - sample program

%C [-f] [-p param] &
Options:
 -f  flag (default off)
 -p  parameter value (default 100)

Examples:
%C -f &
%C -p 20 &
%C -f -p 40 &
#endif
*/


OSample::OSample()
{
	parms_def = (parms_t) {false,100};
}

OSample::~OSample()
{
}

// ------------------------------------------------------------> OptProc <---

void OSample::OptProc(int argc, char** argv, OSample::parms_t* parms)
{
	int  c;

	    						//   ,
	    						//    
	opterr = 0;
	while (1) {
		c = getopt (argc, argv, "fp:");   // <---

		if (c == -1 && argv[optind] == NULL)
			break;

		switch (c) {

		// --->

		case 'f': 
			Opt_f (optarg); 
			break;

		case 'p': 
			Opt_p (optarg); 
			break;

		// <---    

		default:
			Usage ();
			exit (EXIT_FAILURE);
			break;
		}
	}

	*parms = parms_def;
}

// --------------------------------------------------------------> Opt_f <---

void OSample::Opt_f(char* optarg)
{
	parms_def.flag = true;
}

// --------------------------------------------------------------> Opt_p <---

void OSample::Opt_p(char* optarg)
{
	parms_def.param = atoi (optarg);
}


//===========================================================================

