/****************************************************************************

	File    : Sample\Sample\Sample.h  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#ifndef Sample_H
#define Sample_H

#include "Server/Standard/Standard.h"


//     SRR   main().

#define SAMPLE_NAME "sample"

enum sa_types_t {
	sa_t_cmd = ST_TYPE_FIRST + ST_TYPE_STEP * 1,
	sa_t_in,
	sa_t_out,
	sa_t_inout,
	sa_t_delayed,
	sa_t_vectors
};

enum sa_codes_t {
	sa_c_self = ST_CODE_FIRST + ST_CODE_STEP * 1,
	sa_c_pulse,
	sa_c_timer
};

typedef struct sa_r_in_t {
	uint16_t type;
	int in;
} sa_r_in_t;

typedef struct sa_r_inout_t {
	uint16_t type;
	int in;
} sa_r_inout_t;

typedef struct sa_r_delayed_t {
	uint16_t type;
	int in;
} sa_r_delayed_t;

typedef struct sa_r_vectors_t {
	uint16_t type;
	int in_len;
	int out_len;
} sa_r_vectors_t;

typedef union sa_r_msg_t {
	uint16_t type;
	st_r_msg_t standard;
	sa_r_in_t in;
	sa_r_inout_t inout;
	sa_r_delayed_t delayed;
	sa_r_vectors_t vectors;
} sa_r_msg_t;

typedef struct sa_p_out_t {
	int out;
} sa_p_out_t;

typedef struct sa_p_inout_t {
	int out;
} sa_p_inout_t;

typedef struct sa_p_delayed_t {
	int out;
} sa_p_delayed_t;

typedef struct sa_p_vectors_t {
	int out_len;
} sa_p_vectors_t;

typedef union sa_p_msg_t {
	st_p_msg_t standard;
	sa_p_out_t out;
	sa_r_inout_t inout;
	sa_r_delayed_t delayed;
	sa_p_vectors_t vectors;
} sa_p_msg_t;

#endif

//===========================================================================

