/****************************************************************************

	File    : Sample\check\check.cpp  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Sample/check/check.h"
#include "Sample/Sample/ISample.h"
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/neutrino.h>


// ---------------------------------------------------------------> main <---

int main(int argc, char** argv)
{
	ISample p;
	int chid, coid;
	int in, out, rc, out_len;
	char in_vec [100];
	char out_vec [100];
	struct _pulse pulse;
	struct sigevent event;

	chid = ChannelCreate (0);
	if (chid == -1) {
		printf ("Can not create channel\n");
		return 1;
	}

	coid = ConnectAttach (0, 0, chid, _NTO_SIDE_CHANNEL, 0);
	if (coid == -1) {
		printf ("Can not connect\n");
		return 1;
	}

	SIGEV_PULSE_INIT (&event, coid, SIGEV_PULSE_PRIO_INHERIT,
		_PULSE_CODE_MINAVAIL, 0);

	p.OpenErr (p.name, 0);

	rc = p.EventForDelivering (&event);
	printf ("check  event for delivering  rc=%d\n", rc);

	rc = p.Cmd ();

	in = 1;
	rc = p.In (in);
	printf ("check  in   rc=%d  err=%d  in=%d\n", rc, errno, in);

	rc = p.Out (&out);
	printf ("check  out   rc=%d  err=%d  out=%d\n", rc, errno, out);

	in = 2;
	rc = p.Inout (in, &out);
	printf ("check  inout   rc=%d  err=%d  in=%d   out=%d\n", rc, errno, in, out);

	in = 10;
	p.Pulse (in);
	delay (100);

	in = 20;
	printf ("check  before delayed\n");
	rc = p.Delayed (in, &out);
	printf ("check  delayed   rc=%d  err=%d  in=%d   out=%d\n", rc, errno, in, out);

	rc = MsgReceivePulse (chid, &pulse, sizeof (_pulse), NULL);
	printf ("check  received pulse   rc=%d  err=%d  value=%d\n", rc, errno, pulse.value.sival_int);

	strcpy (in_vec, "How do you do?");
	out_len = sizeof (out_vec);
	rc = p.Vectors (in_vec, strlen (in_vec) + 1, out_vec, &out_len);
	printf ("check  vectors  out='%s'   len=%d\n", out_vec, out_len);

	p.Complete ();
	//	p.CompleteByPulse ();

	ConnectDetach (coid);
	ChannelDestroy (chid);

	return EXIT_SUCCESS;
}


//===========================================================================

