/****************************************************************************

	File    : Server\Program\SProgram.cpp  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/Program/SProgram.h"
#include "Server/Program/PProgram.h"
#include "Server/Program/OProgram.h"
#include <errno.h>

SProgram::SProgram()
{
}

// ----------------------------------------------------------> ~SProgram <---

SProgram::~SProgram()
{
	if (pp != NULL) {
		delete (PProgram*) pp;
		pp = NULL;
	}
}

// -----------------------------------------------------> Initialization <---

void SProgram::Initialization(int argc, char** argv, const char** path
, unsigned int* flags, int* rsize, int* psize)
{

	OProgram::parms_t parms;
	OProgram opt;

							//    
	opt.OptProc (argc, argv, &parms);

							//   
	pp = new PProgram ();

							//    
	*path  = (const char*) PROGRAM_NAME;
	*flags = 0; // NAME_FLAG_ATTACH_GLOBAL
	*rsize = sizeof (pr_r_msg_t);
	*psize = sizeof (pr_p_msg_t);
}

// ----------------------------------------------------> ChannelDepended <---

void SProgram::ChannelDepended(int coid)
{
	SStandard::ChannelDepended(coid);
}

// ---------------------------------------------------------> ProcessMsg <---

int SProgram::ProcessMsg(int rcvid, void * r_msg, void * p_msg, int* psize
, struct _msg_info* info)
{
	int status;
	uint16_t type;
	PProgram* p;

	p    = (PProgram*) pp;
	type = ((st_r_cmd_t*) r_msg)->type;

	*psize = 0;
	status = ENOSYS;

	switch (type) {

	// --->

	case pr_t_t1:
		status = p->Func ();
		break;

	// <---    

	default:
		status = SStandard::ProcessMsg (rcvid, r_msg, p_msg, psize, info);
		break;
	}

	return status;
}

// -------------------------------------------------------> ProcessPulse <---

void SProgram::ProcessPulse(struct _pulse* pulse, struct _msg_info* info)
{
	PProgram* p;

	p = (PProgram*) pp;

	switch (pulse->code) {

	// --->



	// <---

	default:
		SStandard::ProcessPulse (pulse, info);
		break;
	}
}


//===========================================================================

