/****************************************************************************

	File    : Server\ServerFix\ServerFix.h  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#ifndef ServerFix_H
#define ServerFix_H

#include <sys/dispatch.h>

//   -.
// 
class ServerFix {

public :

	ServerFix();

	~ServerFix();

	//    -   main()
	void Run(int argc, char** argv);


protected :

	//     
	bool is_srr_running;

	//  

	virtual void Initialization(int argc, char** argv, const char** path
, unsigned int* flags, int* rsize, int* psize) = 0;

	// ,    
	virtual void ChannelDepended(int coid) = 0;

	//  
	virtual int ProcessMsg(int rcvid, void * r_msg, void * p_msg, int* psize
, struct _msg_info* info) = 0;

	//  
	virtual void ProcessPulse(struct _pulse* pulse, struct _msg_info* info
) = 0;


private :

	//  
	const char* path;

	//   ,   
	unsigned int flags;

	//  
	void * r_msg;

	//  
	void * p_msg;

	//   
	name_attach_t* attach;

	//  
	int coid;

	//  

	void Prepare(const char* path, unsigned int flags, int rsize, int psize
, void ** r_msg, void ** p_msg, int* coid, int* chid);

	//      
	void MainLoop(void * r_msg, void * p_msg, int chid, int rsize);

};

#endif

//===========================================================================

