/****************************************************************************

	File    : Server\Standard\IStandard.cpp  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/Standard/IStandard.h"
#include <err.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/dispatch.h>
#include "Server/Standard/Standard.h"


/*
 ,  Open()  Close()     .
     ,     
   .  ,   Open()  
  .  Close() ,    Open().
*/


IStandard::IStandard()
{
	fd = -1;
	name = STANDARD_NAME;
}

IStandard::~IStandard()
{
}

// ---------------------------------------------------------------> Open <---

int IStandard::Open(const char* name, unsigned int flags)
{
	/*
	  100       
	  50 . ,     5  , 
	      .
	*/

	int i;

	for (i = 0; i < 100; i++) {
		rc = name_open (name, flags);

		if (rc == -1 && errno == ENOENT)
			delay (50);
		else
			break;
	}

	fd = rc;

	return rc;
}

// ------------------------------------------------------------> OpenErr <---

int IStandard::OpenErr(const char* name, unsigned int flags)
{
	rc = Open (name, flags);
							if (rc == -1) err (EXIT_FAILURE,
							"Can not open '%s'", name);

	return rc;
}

// --------------------------------------------------------------> Close <---

int IStandard::Close()
{
	rc = name_close (fd);
	fd = -1;

	return rc;
}

// -----------------------------------------------------------> Complete <---

int IStandard::Complete()
{
	st_r_cmd_t s_msg;

	s_msg.type = st_t_quit;
	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}

// ----------------------------------------------------> CompleteByPulse <---

int IStandard::CompleteByPulse()
{
	rc = MsgSendPulse (fd, SIGEV_PULSE_PRIO_INHERIT, st_c_quit, 0);

	return rc;
}

// -------------------------------------------------> EventForDelivering <---

int IStandard::EventForDelivering(struct sigevent* event)
{
	st_r_evdlvr_t s_msg;

	s_msg.type  = st_t_evdlvr;
	s_msg.event = *event;
	rc = MsgSend (fd, &s_msg, sizeof (s_msg), NULL, 0);

	return rc;
}


//===========================================================================

