/****************************************************************************

	File    : Server\Standard\IStandard.h  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#ifndef IStandard_H
#define IStandard_H

#include <sys/siginfo.h>

//    .
// 
class IStandard {

public :

	IStandard();

	~IStandard();

	//  
	const char* name;

	/* 
	// Open
	// --------
	//          .
	// 
	//   .
	//
	// name: [In] -  
	// flags: [In] -   ,   
	*/
	int Open(const char* name, unsigned int flags);

	/* 
	// OpenErr
	// --------
	//          .
	//        .
	// 
	//   .
	//
	// name: [In] -  
	// flags: [In] -   ,   
	*/
	int OpenErr(const char* name, unsigned int flags);

	/* 
	// Close
	// --------
	//       .
	//
	// 
	*/
	int Close();

	/* 
	// Complete
	// --------
	//     .
	//
	// 
	*/
	int Complete();

	/* 
	// CompleteByPulse
	// --------
	//     ,  .
	//
	// 
	*/
	int CompleteByPulse();

	/* 
	// EventForDelivering
	// --------
	//         .
	//
	// event: [In] -   
	*/
	int EventForDelivering(struct sigevent* event);


protected :

	//  
	int fd;

	//  
	int rc;

};

#endif

//===========================================================================

