/****************************************************************************

	File    : Server\Standard\OStandard.cpp  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/Standard/OStandard.h"
#include "Server/tools/tools.h"
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/dispatch.h>


// ==============================================================> usage <===
/*
#ifdef __USAGE
%C - minimal server

%C [-n name] [-g] &
 -n register the name (default "standard")
 -g register as global 
Options:

Examples:
%C -n test -g &
%C -g &
#endif
*/


OStandard::OStandard()
{
	parms_def = (parms_t) {STANDARD_NAME, 0};
}

OStandard::~OStandard()
{
}

// ------------------------------------------------------------> OptProc <---

void OStandard::OptProc(int argc, char** argv, OStandard::parms_t* parms)
{
	int  c;

	    						//   ,
	    						//    
	opterr = 0;
	while (1) {
		c = getopt (argc, argv, "n:g");   // <---

		if (c == -1 && argv[optind] == NULL)
			break;

		switch (c) {

		// --->

		case 'n': 
			Opt_n (optarg); 
			break;

		case 'g': 
			Opt_g (optarg); 
			break;

		// <---    

		default:
			Usage ();
			exit (EXIT_FAILURE);
			break;
		}
	}

	*parms = parms_def;
}

// --------------------------------------------------------------> Opt_n <---

void OStandard::Opt_n(char* optarg)
{
	parms_def.name = optarg;
}

// --------------------------------------------------------------> Opt_g <---

void OStandard::Opt_g(char* optarg)
{
	parms_def.flag = NAME_FLAG_ATTACH_GLOBAL;
}


//===========================================================================

