/****************************************************************************

	File    : Server\tools\tools.cpp  

	Project : Sample.cpp
	Version : 3.4
	Date    : Sun, 1, Jun 2014  

	Copynull (0) Zheltikov I.A.

****************************************************************************/

#include "Server/tools/tools.h"
#include <err.h>
#include <errno.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


// -------------------------------------------------------> CatchSignals <---

int CatchSignals(void (*handler) (int))
{
	/*
	 SIGKILL  SIGSTOP    .
	 SIGCONT     -  .
	*/

	int i;
	void (*func) (int);

	for (i = 1; i < NSIG; i++) {
		if (i != SIGKILL && i != SIGSTOP && i != SIGCONT) {
			func = signal (i, handler);
							if (func == SIG_ERR)
							return -1;
		}
	}

	return EOK;
}

// ------------------------------------------------------> SignalHandler <---

void SignalHandler(int signo)
{
	/*
	    .
	*/

	errx (EXIT_FAILURE, "caught signal (%d). Program terminated", signo);
}

// ------------------------------------------------------> IgnoreSignals <---

int IgnoreSignals()
{
	/*
	    .
	 SIGKILL  SIGSTOP    .
	 SIGCHLD     .
	*/

	int i;
	void (*func) (int);

	for (i = 1; i < NSIG; i++) {
		if (i != SIGKILL && i != SIGSTOP && i != SIGCHLD) {
			func = signal (i, SIG_IGN);
							if (func == SIG_ERR)
							return -1;
		}
	}

	return EOK;
}

// --------------------------------------------------------------> Usage <---

int Usage()
{
	/*
	     
	 system()   "use <progname>".

	  system()      SIGCHLD,
	       .
	*/

	size_t maximum_path;
	size_t length;
	char*  str;
	char*  ptr;
	char   use [] = "use ";
	void (*func) (int);

	maximum_path = pathconf ("/", _PC_PATH_MAX) + 1;
	length = strlen (use);

	str = (char*) malloc (maximum_path + length);
							if (str == NULL)
								return -1;

	strcpy (str, use);

	ptr = _cmdname (str + length);
							if (ptr == NULL) {
								free (str);
								errno = ESRCH;
								return -1;
							}

	func = signal (SIGCHLD, SIG_DFL);
							if (func == SIG_ERR) {
								free (str);
								return -1;
							}

	system (str);

	signal (SIGCHLD, func);

	free (str);

	return EOK;
}


//===========================================================================

